module CurpGenerator::Catalogs
  VALID_CHARACTERS = '0123456789ABCDEFGHIJKLMNÑOPQRSTUVWXYZ'.freeze

  STATES = {
    'AGUASCALIENTES' => 'AS',
    'BAJA CALIFORNIA NORTE' => 'BC',
    'BAJA CALIFORNIA SUR' => 'BS',
    'CAMPECHE' => 'CC',
    'CHIAPAS' => 'CS',
    'CHIHUAHUA' => 'CH',
    'CIUDAD DE MEXICO' => 'DF',
    'COAHUILA' => 'CL',
    'COLIMA' => 'CM',
    'DURANGO' => 'DG',
    'GUANAJUATO' => 'GT',
    'GUERRERO' => 'GR',
    'HIDALGO' => 'HG',
    'JALISCO' => 'JC',
    'MEXICO' => 'MC',
    'MICHOACAN' => 'MN',
    'MORELOS' => 'MS',
    'NAYARIT' => 'NT',
    'NUEVO LEON' => 'NL',
    'OAXACA' => 'OC',
    'PUEBLA' => 'PL',
    'QUERETARO' => 'QT',
    'QUINTANA ROO' => 'QR',
    'SAN LUIS POTOSI' => 'SP',
    'SINALOA' => 'SL',
    'SONORA' => 'SR',
    'TABASCO' => 'TC',
    'TAMAULIPAS' => 'TS',
    'TLAXCALA' => 'TL',
    'VERACRUZ' => 'VZ',
    'YUCATAN' => 'YN',
    'ZACATECAS' => 'ZS'
  }.freeze

  FORBIDDEN_WORDS = {
    'BACA' => 'BXCA',
    'LOCO' => 'LXCO',
    'BAKA' => 'BXKA',
    'BUEI' => 'BXEI',
    'BUEY' => 'BXEY',
    'CACA' => 'CXCA',
    'CACO' => 'CXCO',
    'CAGA' => 'CXGA',
    'CAGO' => 'CXGO',
    'CAKA' => 'CXKA',
    'CAKO' => 'CXKO',
    'COGE' => 'CXGE',
    'COGI' => 'CXGI',
    'COJA' => 'CXJA',
    'COJE' => 'CXJE',
    'COJI' => 'CXJI',
    'COJO' => 'CXJO',
    'COLA' => 'CXLA',
    'CULO' => 'CXLO',
    'FALO' => 'FXLO',
    'FETO' => 'FXTO',
    'GETA' => 'GXTA',
    'GUEI' => 'GXEI',
    'GUEY' => 'GXEY',
    'JETA' => 'JXTA',
    'JOTO' => 'JXTO',
    'KACA' => 'KXCA',
    'KACO' => 'KXCO',
    'KAGA' => 'KXGA',
    'KAGO' => 'KXGO',
    'KAKA' => 'KXKA',
    'KAKO' => 'KXKO',
    'KOGE' => 'KXGE',
    'KOGI' => 'KXGI',
    'KOJA' => 'KXJA',
    'KOJE' => 'KXJE',
    'KOJI' => 'KXJI',
    'KOJO' => 'KXJO',
    'KOLA' => 'KXLA',
    'KULO' => 'KXLO',
    'LILO' => 'LXLO',
    'LOKA' => 'LXKA',
    'LOKO' => 'LXKO',
    'MAME' => 'MXME',
    'MAMO' => 'MXMO',
    'MEAR' => 'MXAR',
    'MEAS' => 'MXAS',
    'MEON' => 'MXON',
    'MIAR' => 'MXAR',
    'MION' => 'MXON',
    'MOCO' => 'MXCO',
    'MOKO' => 'MXKO',
    'MULA' => 'MXLA',
    'MULO' => 'MXLO',
    'NACA' => 'NXCA',
    'NACO' => 'NXCO',
    'PEDA' => 'PXDA',
    'PEDO' => 'PXDO',
    'PENE' => 'PXNE',
    'PIPI' => 'PXPI',
    'PITO' => 'PXTO',
    'POPO' => 'PXPO',
    'PUTA' => 'PXTA',
    'PUTO' => 'PXTO',
    'QULO' => 'QXLO',
    'RATA' => 'RXTA',
    'ROBA' => 'RXBA',
    'ROBE' => 'RXBE',
    'ROBO' => 'RXBO',
    'RUIN' => 'RXIN',
    'SENO' => 'SXNO',
    'TETA' => 'TXTA',
    'VACA' => 'VXCA',
    'VAGA' => 'VXGA',
    'VAGO' => 'VXGO',
    'VAKA' => 'VXKA',
    'VUEI' => 'VXEI',
    'VUEY' => 'VXEY',
    'WUEI' => 'WXEI',
    'WUEY' => 'WXEY'
  }.freeze

  COMMON_NAMES = [
    'MARIA DEL',
    'MARIA DE LOS',
    'MARIA',
    'JOSE DE',
    'JOSE',
    'MA.',
    'MA',
    'M.',
    'J.',
    'J'
  ].freeze

  COMPOSED_NAMES = [
    'DA ',
    'DAS ',
    'DE ',
    'DEL ',
    'DER ',
    'DI ',
    'DIE ',
    'DD ',
    'EL ',
    'LA ',
    'LOS ',
    'LAS ',
    'LE ',
    'LES ',
    'MAC ',
    'MC ',
    'VAN ',
    'VON ',
    'Y '
  ].freeze
end
